-- m19lib 1.2 lite version


include asm.e
include ports.e
include machine.e

without warning

global constant no_fading=-666
global constant no_delay=-667

sequence inRegs,outRegs
global sequence clip_box_coords

outRegs={0,0,0,0,0,0,0,0,0,0}
inRegs=outRegs
clip_box_coords={{0,0},{319,199}}


global procedure set_vga()
outRegs={0,0,0,0,0,0,0,0,0,0}
outRegs[REG_AX]=#13
inRegs=dos_interrupt(#10,outRegs)
end procedure

global procedure restore_graphics()
if machine_func(5,-1) then end if
end procedure

function abs(integer num1)
if (num1<0) then
num1=-num1
end if
return num1
end function

global function diff(integer num1,integer num2)
integer retNum
if (num1>=0) and (num2>=0) then
retNum=abs(num1-num2)
end if
if (num1>=0) and (num2<0) then
retNum=num1+abs(num2)
end if
if (num1<0) and (num2>=0) then
retNum=abs(num1)+num2
end if
if (num1<0) and (num2<0) then
retNum=abs(num1-num2)
end if
return retNum
end function

constant wait_vrt_code=get_asm(
"pusha cld "&
"mov edx,986 "&
"waitLbl1: "&
"in ax,dx "&
"and al,8 "&
"jnz waitLbl1 "&
"waitLbl2: "&
"in ax,dx "&
"and al,8 "&
"jz waitLbl2 "&
"popa ret")

global procedure wait_vrt()
call(wait_vrt_code)
end procedure



constant asm_d_dispclip_code=get_asm(
"pusha cld "&
"mov eax,d_asm_dispclip_y "&
"shl eax,6 "&
"mov ebx,eax "&
"shl eax,2 "&
"add ebx,eax "&
"add ebx,d_asm_dispclip_x "&
"add ebx,d_dispclip_screen_addr "&
"mov edi,ebx "&
"mov ebx,d_clipbmp_img_addr "&
"mov esi,ebx "&
"mov edx,d_clipbmp_ydim "&
"xor eax,eax "&
"d_asmDispclipLoop: "&
"mov ecx,d_clipbmp_xdim "&
"rep movsd "&
"inc eax "&
"cmp eax,edx "&
"je d_asmDispclipDone "&
"add edi,d_dispclip_offs_add "&
"add esi,d_clipimg_offs_add "&
"jmp d_asmDispclipLoop "&
"d_asmDispclipDone: "&
"popa ret ")
constant d_asm_dispclip_x=asm_d_dispclip_code+get_param("d_asm_dispclip_x")
constant d_asm_dispclip_y=asm_d_dispclip_code+get_param("d_asm_dispclip_y")
constant d_dispclip_screen_addr=asm_d_dispclip_code+get_param("d_dispclip_screen_addr")
constant d_clipbmp_img_addr=asm_d_dispclip_code+get_param("d_clipbmp_img_addr")
constant d_clipbmp_xdim=asm_d_dispclip_code+get_param("d_clipbmp_xdim")
constant d_clipbmp_ydim=asm_d_dispclip_code+get_param("d_clipbmp_ydim")
constant d_dispclip_offs_add=asm_d_dispclip_code+get_param("d_dispclip_offs_add")
constant d_clipimg_offs_add=asm_d_dispclip_code+get_param("d_clipimg_offs_add")
--constant d_clip_odd_pixel=asm_d_dispclip_code+get_param("d_clip_odd_pixel")



global procedure asm_display_clip(sequence coords,sequence tha_img,atom tha_screen_addr)
integer bmpXdim,bmpYdim,xEnd,yEnd
integer clippedXdim,clippedYdim
integer clipX,clipY,xLen,yLen
integer startOffsAdd,clipOffsAdd,noDisp
integer odd_byte
bmpXdim=(tha_img[2])
bmpYdim=(tha_img[3])
xLen=bmpXdim
yLen=bmpYdim
startOffsAdd=0
clipOffsAdd=0
clipX=coords[1]
clipY=coords[2]
xEnd=(coords[1]+bmpXdim-1)
yEnd=(coords[2]+bmpYdim-1)
noDisp=0
if coords[1]<clip_box_coords[1][1] then
if xEnd<clip_box_coords[1][1] then
noDisp=1
end if
clipX=clip_box_coords[1][1]
startOffsAdd=clipX-coords[1]
clipOffsAdd=startOffsAdd
xLen=xLen-startOffsAdd
end if
if coords[2]<clip_box_coords[1][2] then
if yEnd<clip_box_coords[1][2] then
noDisp=1
end if
clipY=clip_box_coords[1][2]
startOffsAdd=startOffsAdd+((clipY-coords[2])*bmpXdim)
yLen=yLen-(clipY-coords[2])
end if
if (coords[1]>clip_box_coords[2][1]) or (coords[2]>clip_box_coords[2][2]) then
noDisp=1
end if
if xEnd>clip_box_coords[2][1] then
xLen=xLen-(xEnd-clip_box_coords[2][1])
clipOffsAdd=clipOffsAdd+(xEnd-clip_box_coords[2][1])
end if
if yEnd>clip_box_coords[2][2] then
yLen=yLen-(yEnd-clip_box_coords[2][2])
end if
if noDisp=0 then
 odd_byte=xLen-(floor(xLen/2)*2)
 poke4(d_asm_dispclip_x,clipX)
 poke(d_asm_dispclip_y,clipY)
 poke(d_clipbmp_xdim,floor(xLen/4))
 poke(d_clipbmp_ydim,yLen)
 poke4(d_dispclip_offs_add,(320-xLen))
 poke4(d_clipbmp_img_addr,(tha_img[1])+startOffsAdd)
 poke4(d_dispclip_screen_addr,tha_screen_addr)
 poke4(d_clipimg_offs_add,clipOffsAdd)
 call(asm_d_dispclip_code)
end if
end procedure



constant copy_screen_code=get_asm(
"pusha cld "&
"mov ebx,copy_dest_addr "&
"mov edi,ebx "&
"mov ebx,copy_src_addr "&
"mov esi,ebx "&
"mov ecx,16000 "&
"rep movsd "&
"popa ret ")
constant copy_dest_addr=copy_screen_code+get_param("copy_dest_addr")
constant copy_src_addr=copy_screen_code+get_param("copy_src_addr")

global procedure asm_copy_screen(atom src,atom dest)
poke4(copy_dest_addr,dest)
poke4(copy_src_addr,src)
call(copy_screen_code)
end procedure

global procedure mem_cls(atom tha_screen_addr,integer tha_col)
mem_set(tha_screen_addr,tha_col,64000)
end procedure


global function set_col(sequence tha_pal2,integer tha_col_num,sequence tha_pal)
Output(tha_col_num,#3C8)
Output(tha_pal[1],#3C9)
Output(tha_pal[2],#3C9)
Output(tha_pal[3],#3C9)
tha_pal2[tha_col_num+1]=tha_pal
return tha_pal2
end function


global procedure set_pal(sequence tha_pal)
for i=1 to 256 do
Output(i-1,#3C8)
Output(tha_pal[i][1],#3C9)
Output(tha_pal[i][2],#3C9)
Output(tha_pal[i][3],#3C9)
end for
end procedure


global procedure free_asm_code()
free(asm_d_dispclip_code)
free(copy_screen_code)
free(wait_vrt_code)
end procedure



global procedure short_delay(integer delays)
poke(1132,0)
while peek(1132)<delays do
end while
end procedure


global function fade_to_rgb(sequence tha_pal_array,sequence to_rgb,integer tha_delay)
integer done_fading
done_fading=0
while done_fading=0 do
done_fading=1
for i=1 to 256 do
 for j=1 to 3 do
  if tha_pal_array[i][j]>to_rgb[j] then
   tha_pal_array[i][j]=tha_pal_array[i][j]-1
   done_fading=0
   end if
  if tha_pal_array[i][j]<to_rgb[j] then
   tha_pal_array[i][j]=tha_pal_array[i][j]+1
   done_fading=0
  end if
 end for
if tha_delay!=no_fading then
Output(i-1,#3C8)
Output(tha_pal_array[i][1],#3C9)
Output(tha_pal_array[i][2],#3C9)
Output(tha_pal_array[i][3],#3C9)
end if
end for
if (tha_delay!=no_fading) and (tha_delay!=no_delay) then
--short_delay(tha_delay)
for nnn=1 to tha_delay do
wait_vrt()
end for
end if
end while
return tha_pal_array
end function

