--Landscape generator & renderer a.k.a. voxel effect for Euphoria 2.1+.
--Written by Mic, 1999/2000.
--Based on the program 'newvox.c' by Andrea Griffini a.k.a. 6502 of Fatal Rage, 199?.
--A PentiumII or higher is recommended since this program is extremely slow. The 'line'
--procedure seems to be a serious bottleneck. Speeding up this procedure a bit would 
--probably give the program a boost.
--On a PentiumII-450 this program runs at:
-- 70 fps without antialiasing
-- ~45 fps with antialiasing
 

without warning		--|
without type_check	--| don't need this..

include m19lib_l.e


constant PI=3.141592654

object junk,junk2

atom st,et,frames

sequence HMap,CMap
 HMap=repeat(0,65536)
 CMap=HMap

atom asm_lasty, asm_lastc
 asm_lasty=allocate(320*4*2)
 asm_lastc=asm_lasty+(320*4)

atom asm_HMap,asm_CMap
 asm_HMap=allocate(65536)	--heightmap
 asm_CMap=allocate(65536)	--colormap

sequence sine,cosine,
         sine_fix,cosine_fix

 sine=repeat(0,720)
 cosine=sine
 sine_fix=sine
 cosine_fix=sine  
 for i=1 to 720 do
  sine[i]=sin((i-360)*PI/180)
  cosine[i]=cos((i-360)*PI/180)
  sine_fix[i]=floor(sine[i]*65536)	--just to save some calculations later on..
  cosine_fix[i]=floor(cosine[i]*65536)	--...
 end for

function deg2rad(atom x)
 return (x*180/PI)
end function

atom vscreen
 vscreen=allocate(64000)



if (asm_HMap<=0) or(asm_CMap<=0) or
   (asm_lasty<=0) or (vscreen<=0) then
 abort(1)
end if




function Cut_255(integer x)
 if x<0 then return 0 end if
 if x>255 then return 255 end if
 return x
end function


--create a heightmap and a colormap
procedure ComputeMap()
integer p,i,j,k,k2,p2
integer a,b,c,d
 HMap[1]=128
 p=256
 while p>1 do
  p2=floor(p/2)
  k=p*8+20
  k2=floor(k/2)
  i=0
  while i<256 do
   j=0
   while j<256 do
    a=HMap[(i*256)+j+1]
    b=HMap[(and_bits((i+p),255)*256)+j+1]
    c=HMap[(i*256)+and_bits((j+p),255)+1]
    d=HMap[(and_bits((i+p),255)*256)+and_bits((j+p),255)+1]
    HMap[(i*256)+and_bits((j+p2),255)+1]=
      Cut_255(floor((a+c)/2)+(remainder(rand(3000),k)-k2))
    HMap[(and_bits((i+p2),255)*256)+and_bits((j+p2),255)+1]=
      Cut_255(floor((a+b+c+d)/4)+(remainder(rand(3000),k)-k2))
    HMap[(and_bits((i+p2),255)*256)+j+1]=
      Cut_255(floor((a+b)/2)+(remainder(rand(3000),k)-k2))
    j+=p
   end while
   i+=p
  end while
  p=p2
 end while
 k=0
 while k<3 do
  i=0
  while i<(255*256) do
   j=0
   while j<256 do
    HMap[i+j+1]=floor((HMap[and_bits((i+256),#FF00)+j+1]+HMap[i+and_bits((j+1),255)+1]+
                 HMap[and_bits((i-256),#FF00)+j+1]+HMap[i+and_bits((j-1),255)+1])/4)
    j+=1
   end while
   i+=256
  end while
  k+=1
 end while
 i=0
 while i<(255*256) do
  j=0
  while j<256 do
   k=128+((HMap[and_bits((i+256),#FF00)+and_bits((j+1),255)+1]-HMap[i+j+1])*4)
   k=Cut_255(k)
   CMap[i+j+1]=k
   j+=1
  end while
  i+=256
 end while
 poke(asm_HMap,HMap)
 poke(asm_CMap,CMap)
 HMap={}
 CMap={} 
end procedure






--line_data
atom ld
 ld=allocate(88)
 if ld<=0 then
  abort(1)
 end if

constant X0=0, Y0=4,
         U0=8, V0=12,
         U1=16, V1=20,
         A=24, B=28,
         H0=32, H1=36,
         H2=40, H3=44,
         H=48, HY=52,
         C=56, CC=60,
         SC=64, I=68,
         SX=72, SY=76,
         Y=80, S=84

constant line=get_asm(
"pusha "&
"mov esi,320 "&
"mov eax,[x0] "&
"mov ebx,[y0] "&
"mov ecx,eax "&
"mov edx,ebx "&
"sar eax,16 "&		--\
"and eax,255 "&		-- \
"sar ebx,8 "&		--  | u0 = ((x0>>16) & #00FF)
"and ebx,65280 "&	--  | v0 = ((y0>>8) & #FF00)
"mov [u0],eax "&	-- /	
"mov [v0],ebx "&	--/	
"inc eax "&		--\
"and eax,255 "&		-- \
"add ebx,256 "&		--  | u1 = ((u0+1) & #00FF)
"and ebx,65280 "&	--  | v1 = ((v0+256) & #FF00)
"mov [u1],eax "&	-- /
"mov [v1],ebx "&	--/
"mov eax,[x0] "&
"sar eax,8 "&		--\
"and eax,255 "&		-- \
"sar edx,8 "&		--  | a = ((x0>>8) & #00FF)
"and edx,255 "&		--  | b = ((y0>>8) & #00FF)
"mov [a],eax "&		-- /
"mov [b],edx "&		--/
"mov eax,[u0] "&
"or eax,[v0] "&		--eax = u0+v0
"mov ebx,[u1] "&	
"or ebx,[v0] "&		--ebx = u1+v0
"mov ecx,[u0] "&
"or ecx,[v1] "&		--ecx = u0+v1
"mov edx,[u1] "&
"or edx,[v1] "&		--edx = u1+v1
"mov al,[HMap + eax] "&
"mov bl,[HMap + ebx] "&
"mov cl,[HMap + ecx] "&
"mov dl,[HMap + edx] "&
"and eax,255 and ebx,255 and ecx,255 and edx,255 "&
"mov [h0],eax mov [h1],ebx mov [h2],ecx mov [h3],edx "&
"mov ebx,[h1] "&
"sub ebx,[h0] "&
"mov eax,[a] "&
"imul ebx "&
"mov edx,[h0] "&
"shl edx,8 "&
"add edx,eax "&
"mov [h0],edx "&
"shl ecx,8 "&
"mov ebx,[h3] "&
"sub ebx,[h2] "&
"mov eax,[a] "&
"imul ebx "&
"add eax,ecx "&
"mov [h2],eax "&
"mov ecx,[h0] "&	-- \
"shl ecx,8 "&		--  \ 
"mov ebx,[h2] "&	--   |
"sub ebx,[h0] "&	--   | h = (((h0<<8)+b*(h2-h0))>>16)
"mov eax,[b] "&		--   |
"imul ebx "&		--   |
"add eax,ecx "&		--  /
"shr eax,16 "&		-- /
"mov [h],eax "&		--/
"mov eax,[u0] "&
"or eax,[v0] "&
"mov ebx,[u1] "&
"or ebx,[v0] "&
"mov ecx,[u0] "&
"or ecx,[v1] "&
"mov edx,[u1] "&
"or edx,[v1] "&
"mov al,[CMap + eax] "&
"mov bl,[CMap + ebx] "&
"mov cl,[CMap + ecx] "&
"mov dl,[CMap + edx] "&
"and eax,255 and ebx,255 and ecx,255 and edx,255 "&
"mov [h0],eax mov [h1],ebx mov [h2],ecx mov [h3],edx "&
"mov ebx,[h1] "&
"sub ebx,[h0] "&	
"mov eax,[a] "&		
"imul ebx "&		
"mov edx,[h0] "&
"shl edx,8 "&
"add edx,eax "&		
"mov [h0],edx "&	
"mov edx,ecx "&
"shl ecx,8 "&
"mov ebx,[h3] "&
"sub ebx,edx "&
"mov eax,[a] "&
"imul ebx "&
"add eax,ecx "&
"mov [h2],eax "&	--\
"mov ecx,[h0] "&	-- \
"mov edx,ecx "&		--  \
"sal ecx,8 "&		--   |
"mov ebx,[h2] "&	--   | c = (h0<<8)+b*(h2-h0)	
"sub ebx,edx "&		--   |
"mov eax,[b] "&		--   |
"imul ebx "&		--  /
"add eax,ecx "&		-- /
"mov [c],eax "&		--/
"mov eax,[h] "&		--\
"sub eax,[hy] "&	-- \	
"mov ebx,[s] "&		--  |
"imul ebx "&		--  | y = ((((h-hy)*s)>>11)+100)
"sar eax,11 "&		--  |
"add eax,100 "&		-- /
"mov [y],eax "&		--/
"mov ebx,[i] "&
"mov ecx,[lasty + ebx] "&
"mov [a],ecx "&		--a = lasty[i]
"cmp eax,ecx "&		--IF (y>=a) THEN
"jnge do_stuff "&
"jmp imouttahere "&	--  GOTO imouttahere
"do_stuff: "&		--END IF
"mov eax,esi "&		--\  (esi=320)
"mul ecx "&		-- \
"mov ecx,[i] "&		--  |
"shr ecx,2 "&		--  | (byte *)vscreen = (dest+(a*320)+i)
"add eax,ecx "&		--  |
"mov edi,eax "&		-- /
"add edi,dest "&	--/
"mov eax,[lastc + ebx] "&
"cmp eax,-1 "&
"jne lastc_ne_minus1 "&
"mov eax,[c] "&
"mov [lastc + ebx],eax "&
"lastc_ne_minus1: "&
"mov [cc],eax "&	--cc = lastc[i]
"mov edx,[c] "&		--\
"sub edx,eax "&		-- \
"mov eax,edx "&		--  |
"mov ebx,[a] "&		--  |
"sub ebx,[y] "&		--  | sc = ((c-lastc[i])/(a-y))
"cwd "&			--  |
"idiv ebx "&		-- /
"mov [sc],eax "&	--/
"mov eax,[a] "&
"cmp eax,199 "&		--IF (a>199) THEN	
"jng a_ng_199 "&	
"sub eax,199 "&		
"mov ebx,eax "&
"mov ecx,esi "&		--(esi=320)
"mul ecx "&
"sub edi,eax "&		--  (byte *)vscreen -= ((a-199)*320)
"mov eax,[sc] "&
"imul ebx "&
"jmp hq "&
"imouttahere: "&
"jmp return "&
"hq: "&
"add [cc],eax "&	--  cc += ((a-199)*sc)
"mov eax,199 "&		 
"mov [a],eax "&		--  a = 199
"a_ng_199: "&		--END IF
"mov eax,[y] "&
"cmp eax,0 "&
"jnl y_nl_0 "&		--IF (y<0) THEN
"xor eax,eax "&		
"mov [y],eax "&		--  y = 0
"y_nl_0: "&  		--END IF
"mov ebx,[cc] "&	--\
"mov edx,[sc] "&	-- \ 
"mov ecx,[y] "&		--  \ 
"mov ebp,[a] "&		--   \
"draw: "&		--    |
"mov eax,ebx "&		--    |
"shr eax,17 "&		--    | finally draw the stuff
"stosb "&		--    |
"sub edi,321 "&		--    |
"add ebx,edx "&		--   /
"dec ebp "&		--  /
"cmp ebp,ecx "&		-- /
"jge draw "&		--/
"mov ebx,[i] "&
"mov [lasty + ebx],ecx "&
"return: "&
"mov ebx,[i] "&
"mov eax,[c] "&
"mov [lastc + ebx],eax "&
"add ebx,4 "&		--increase position in tables	
"mov [i],ebx "&
"mov eax,[sx] "&
"mov ebx,[sy] "&
"add [x0],eax "&	--x0 += sx
"add [y0],ebx "&	--y0 += sy
"popa ret")
resolve_param("x0",ld+X0)
resolve_param("y0",ld+Y0)
resolve_param("u0",ld+U0)
resolve_param("v0",ld+V0)
resolve_param("u1",ld+U1)
resolve_param("v1",ld+V1)
resolve_param("a",ld+A)
resolve_param("b",ld+B)
resolve_param("c",ld+C)
resolve_param("h",ld+H)
resolve_param("i",ld+I)
resolve_param("s",ld+S)
resolve_param("y",ld+Y)
resolve_param("h0",ld+H0)
resolve_param("h1",ld+H1)
resolve_param("h2",ld+H2)
resolve_param("h3",ld+H3)
resolve_param("hy",ld+HY)
resolve_param("cc",ld+CC)
resolve_param("sc",ld+SC)
resolve_param("sx",ld+SX)
resolve_param("sy",ld+SY)
resolve_param("HMap",asm_HMap)
resolve_param("CMap",asm_CMap)
resolve_param("lasty",asm_lasty)
resolve_param("lastc",asm_lastc)
resolve_param("dest",vscreen)



--calc_stuff_data
atom cd
 cd=allocate(52)
 if cd<=0 then
  abort(1)
 end if

constant calc_stuff=get_asm(
"pusha cld "&
"mov edi,dest "&	--\
"mov eax,200 "&		-- \
"mov ecx,320 "&		--  |
"rep stosd "&		--  | reset y & c buffers 
"mov eax,-1 "&		--  |
"mov ecx,320 "&		-- /
"rep stosd "&		--/
"mov eax,[x0] "&
"mov ebx,[y0] "&
"sar eax,16 "&
"sar ebx,8 "&
"and eax,255 "&
"and ebx,65280 "&
"mov [u0],eax "&
"mov [v0],ebx "&
"inc eax "&
"add ebx,256 "&
"and eax,255 "&
"and ebx,65280 "&
"mov [u1],eax "&
"mov [v1],ebx "&
"mov eax,[x0] "&
"mov ebx,[y0] "&
"sar eax,8 "&
"sar ebx,8 "&
"and eax,255 "&
"and ebx,255 "&
"mov [a],eax "&
"mov [b],ebx "&
"mov eax,[u0] "&
"or eax,[v0] "&		--eax = u0+v0
"mov ebx,[u1] "&	
"or ebx,[v0] "&		--ebx = u1+v0
"mov ecx,[u0] "&
"or ecx,[v1] "&		--ecx = u0+v1
"mov edx,[u1] "&
"or edx,[v1] "&		--edx = u1+v1
"mov al,[HMap + eax] "&
"mov bl,[HMap + ebx] "&
"mov cl,[HMap + ecx] "&
"mov dl,[HMap + edx] "&
"and eax,255 and ebx,255 and ecx,255 and edx,255 "&
"mov [h0],eax mov [h1],ebx mov [h2],ecx mov [h3],edx "&
"mov ebx,[h1] "&
"sub ebx,[h0] "&
"mov eax,[a] "&
"imul ebx "&
"mov edx,[h0] "&
"shl edx,8 "&
"add edx,eax "&
"mov [h0],edx "&
"shl ecx,8 "&
"mov ebx,[h3] "&
"sub ebx,[h2] "&
"mov eax,[a] "&
"imul ebx "&
"add eax,ecx "&
"mov [h2],eax "&
"mov ecx,[h0] "&	-- \
"shl ecx,8 "&		--  \ 
"mov ebx,[h2] "&	--   |
"sub ebx,[h0] "&	--   | h = (((h0<<8)+b*(h2-h0))>>16)
"mov eax,[b] "&		--   |
"imul ebx "&		--   |
"add eax,ecx "&		--  /
"shr eax,16 "&		-- /
"mov [h],eax "&		--/
"popa ret")
resolve_param("dest",asm_lasty)
resolve_param("x0",cd+X0)
resolve_param("y0",cd+Y0)
resolve_param("u0",cd+U0)
resolve_param("v0",cd+V0)
resolve_param("u1",cd+U1)
resolve_param("v1",cd+V1)
resolve_param("a",cd+A)
resolve_param("b",cd+B)
resolve_param("h",cd+H)
resolve_param("h0",cd+H0)
resolve_param("h1",cd+H1)
resolve_param("h2",cd+H2)
resolve_param("h3",cd+H3)
resolve_param("HMap",asm_HMap)



--trilinear antialiasing
--
--    -1 0 1 (x)
--  -1 . . .
--
--   0 . * .
--
--   1 . . .
--
--  (y)
--
--Mix the 8 pixels marked as '.', then mix that pixel with the '*'-pixel
--to get the final color.
constant triLin_alias=get_asm(
"pusha cld "&
"mov esi,triLinAddr "&
"add esi,321 "&
"mov ecx,198 "&
"triLin_yloop: "&
"push ecx, "&
"push esi "&
"mov ecx,318 "&
"triLin_xloop: "&
"xor ax,ax "&
"xor bx,bx "&
"mov al,[esi-1] "&	--col=point(x-1,y)
"mov bx,ax "&
"mov al,[esi+1] "&	--col+=point(x+1,y)
"add bx,ax "&
"mov al,[esi-320] "&	--col+=point(x,y-1)
"add bx,ax "&
"mov al,[esi+320] "&	--col+=point(x,y+1)
"add bx,ax "&
"mov al,[esi-321] "&	--col+=point(x-1,y-1)
"add bx,ax "&
"mov al,[esi-319] "&	--col+=point(x+1,y-1)
"add bx,ax "&
"mov al,[esi+321] "&	--col+=point(x+1,y+1)
"add bx,ax "&
"mov al,[esi+319] "&	--col+=point(x-1,y+1)
"add bx,ax "&
"shr bx,3 "&		--col/=8
"mov al,[esi] "&	--col+=point(x,y)
"add bx,ax "&
"shr bx,1 "&		--col/=2
"mov [esi],bl "&	--point(x,y)=col
"inc esi "&
"dec cx "&
"jnz triLin_xloop "&
"pop esi "&
"pop ecx "&
"add esi,320 "&
"dec cx "&
"jnz triLin_yloop "&
"popa ret")
resolve_param("triLinAddr",vscreen)

 
atom FOV
 FOV=60		--60 degrees Field Of Vision

procedure View(integer x0,integer y0,atom aa)
integer d
integer a,b,h,u0,v0,u1,v1,h0,h1,h2,h3
integer i,sx,sy
integer p1x,p1y,p2x,p2y
integer vmin,vmax
 poke4(cd+X0,x0)
 poke4(cd+Y0,y0)
 call(calc_stuff)
 h=peek4s(cd+H)
 vmin=remainder(floor(aa-FOV),360)+361
 vmax=remainder(floor(aa+FOV),360)+361 
 d=0
 --52 (below) is the drawing-depth. It was 100 in the original C-version, but that'd be
 --way too slow. People with P3:s/Athlons and such could try a higher value (like 80..).
 --A higher value means less stuff "coming out of nowhere".
 while d<52 do		
  p1x=x0+d*cosine_fix[vmin]
  p1y=y0+d*sine_fix[vmin]
  p2x=x0+d*cosine_fix[vmax]
  p2y=y0+d*sine_fix[vmax]
  sx=floor((p2x-p1x)/320)
  sy=floor((p2y-p1y)/320)
  i=0
  poke4(ld+I,0)
  poke4(ld+X0,p1x)
  poke4(ld+Y0,p1y)
  poke4(ld+SX,sx)
  poke4(ld+SY,sy)
  poke4(ld+HY,(h-30))
  poke4(ld+S,floor(25600/(d+1)))
  while i<320 do	
   call(line)
   i+=1
  end while
  d+=1+floor(d/64)
 end while
end procedure




--main() {

integer i,k
atom ss,sa,a,s
integer x0,y0
integer alias


puts(1,"              Landscape generator and renderer for Euphoria 2.1+\n")
puts(1,"                              By ")
machine_proc(9,1)
puts(1,"M")
machine_proc(9,9)
puts(1,"i")
machine_proc(9,15)
puts(1,"c")
machine_proc(9,7)		--machine_proc(9,x) = text_color(x)
puts(1,", 1999/2000\n\n\n")
puts(1,"The keys are:\n")
machine_proc(9,15)
puts(1," UP")
machine_proc(9,7)
puts(1,": Move forward\n")
machine_proc(9,15)
puts(1," DOWN")
machine_proc(9,7)
puts(1,": Move backward\n")
machine_proc(9,15)
puts(1," RIGHT")
machine_proc(9,7)
puts(1,": Turn clockwise\n")
machine_proc(9,15)
puts(1," LEFT")
machine_proc(9,7)
puts(1,": Turn anti-clockwise\n")
machine_proc(9,15)
puts(1," a")
machine_proc(9,7)
puts(1,": Turn antialiasing ON (not recommended unless machine>=PentiumII)\n")
machine_proc(9,15)
puts(1," s")
machine_proc(9,7)
puts(1,": Turn antialiasing OFF\n")
machine_proc(9,15)
puts(1," Esc")
machine_proc(9,7)
puts(1,": Exit program \n")
puts(1,"\nPress any key...")

while get_key()=-1 do
end while



set_vga()

i=0
while i<64 do			--\
 Output(i,#3C8)			-- \
 Output(i,#3C9)			--  \
 Output(0,#3C9)			--   |
 Output(0,#3C9)			--   | set palette
 Output(i+64,#3C8)		--   |
 Output(63,#3C9)		--  /
 Output(i,#3C9)			-- /
 Output(floor(i/1.2),#3C9)	--/
 i+=1
end while


ComputeMap()


a=40
k=0
x0=4096*5
y0=4096*5
s=4096
ss=0
sa=0


alias=0
frames=0
st=time()

while k!=27 do
 mem_set(vscreen,0,64000)
 View(x0,y0,a)
 if alias then
  call(triLin_alias) 
 end if
 while (and_bits(Input(#3DA),8)) do	--\
 end while				-- |
 while (and_bits(Input(#3DA),8)=0) do	-- | wait for vertical retrace
 end while				--/
 asm_copy_screen(vscreen,#A0000)
 frames+=1
 x0+=floor((ss*cosine[remainder(floor(a),360)+361]))
 y0+=floor((ss*sine[remainder(floor(a),360)+361]))
 a+=sa
 k=get_key()
 if k=331 then sa-=0.29 end if
 if k=333 then sa+=0.29 end if
 if k=328 then ss+=s end if
 if k=336 then ss-=s end if
 if k='a' then alias=1 end if
 if k='s' then alias=0 end if
end while
et=time()



free(vscreen)
free(asm_HMap)
free(asm_CMap)
free(asm_lasty)

restore_graphics()

printf(1,"%d fps\n\n",floor(frames/(et-st)))

--} 

